<?php

/* * ********************************************************************
 * InterNetX registrar module. Product developed. (2014-02-21)
 * *
 *
 *  CREATED BY MODULESGARDEN       ->       http://modulesgarden.com
 *  CONTACT                        ->       contact@modulesgarden.com
 *
 *
 * This software is furnished under a license and may be used and copied
 * only  in  accordance  with  the  terms  of such  license and with the
 * inclusion of the above copyright notice.  This software  or any other
 * copies thereof may not be provided or otherwise made available to any
 * other person.  No title to and  ownership of the  software is  hereby
 * transferred.
 *
 *
 * ******************************************************************** */

use Illuminate\Database\Capsule\Manager as Capsule;
use WHMCS\Domains\DomainLookup\ResultsList;
use WHMCS\Domains\DomainLookup\SearchResult;

/**
 * @author Pawel Kopec <pawelk@modulesgarden.com>
 */
defined('DS') ? '' : define('DS', DIRECTORY_SEPARATOR);
/*
 * DEBUG MODE
 */
//if ($_REQUEST['_debug'] == 'turnon') {
//    $_SESSION['internetx_debug'] = 1;
//} elseif ($_REQUEST['_debug'] == 'turnoff') {
//    $_SESSION['internetx_debug'] = NULL;
//}

require_once ROOTDIR . DS . 'modules' . DS . 'registrars' . DS . 'InterNetX' . DS . 'utility.php';
//internetx_debug();
internetx_load();

/**
 * FUNCTION InterNetX_getConfigArray
 * Array contains the module configuration
 * @return array $configarray
 */
function InterNetX_getConfigArray()
{
    $admins = (array) Capsule::table('tbladmins')->select('email')->orderBy('email', 'asc')->get();
    $adminEmails = array();
    foreach ($admins as $admin)
        $adminEmails[] = $admin->email;


    $configArray = array
        (
        "FriendlyName" => array(
            "Type" => "System",
            "Value" => "InterNetX",
        ),
        "Description" => array(
            "Type" => "System",
            "Value" => "Get your free InterNetX Reseller Account here: <a href=\"https://www.internetx.com\" target=\"_blank\">https://www.internetx.com</a>.",
        ),
        "serverUsername" => array
            (
            'FriendlyName' => 'Username',
            "Type" => "text",
            "Size" => "20",
            "Description" => "Enter your username here.",
        ),
        "serverPassword" => array
            (
            'FriendlyName' => 'Password',
            "Type" => "password",
            "Size" => "20",
            "Description" => "Enter your password here.",
        ),
        "serverContext" => array
            (
            'FriendlyName' => 'Context',
            "Type" => "text",
            "Size" => "20",
            "Description" => "Enter your context here.",
        ),
        'serverHost' => array
            (
            'FriendlyName' => 'Server',
            'Type' => 'text',
            'Size' => '20',
            "Description" => "Provide your API url. Eg. https://gateway.autodns.com",
        ),
        'nameServers' => array
            (
            'FriendlyName' => 'Default Nameservers',
            "Type" => "textarea",
            "Rows" => "3",
            "Cols" => "18",
            "Default" => "",
            "Description" => "Provide your Default Nameservers (for Zone) Eg. ns1.demo.autodns2.de",
        ),
        "sandboxServerUsername" => array
            (
            'FriendlyName' => 'Sandbox Username',
            "Type" => "text",
            "Size" => "20",
            "Description" => "Enter your sandbox username here.",
        ),
        "sandboxServerPassword" => array
            (
            'FriendlyName' => 'Sandbox Password',
            "Type" => "password",
            "Size" => "20",
            "Description" => "Enter your sandbox password here.",
        ),
        "sandboxServerContext" => array
            (
            'FriendlyName' => 'Sandbox Context',
            "Type" => "text",
            "Size" => "20",
            "Description" => "Enter your sandbox context here.",
        ),
        'sandboxNameServers' => array
            (
            'FriendlyName' => 'Sandbox Default Nameservers',
            "Type" => "textarea",
            "Rows" => "3",
            "Cols" => "18",
            "Default" => "ns1.demo.autodns2.de\nns2.demo.autodns2.de",
            "Description" => "Provide your Default Nameservers (for Zone) Eg. ns1.demo.autodns2.de",
        ),
        'replyTo' => array
            (
            'FriendlyName' => 'Reply To',
            'Type' => 'dropdown',
            "Description" => "",
            "Options" => implode(",", $adminEmails),
            "Description" => "Contact address for support team in case of errors.",
        ),
        'domainMX' => array
            (
            'FriendlyName' => 'MX Record',
            "Type" => "text",
            "Size" => "20",
            "Description" => "MX record (mailserver). Enter the complete domain host name of the mailserver.",
        ),
        'domainIP' => array
            (
            'FriendlyName' => 'IP Address',
            "Type" => "text",
            "Size" => "20",
            "Description" => "IP address of the zone (A Record).",
        ),
        'autodelete' => array
            (
            'FriendlyName' => 'Auto Delete',
            'Type' => 'yesno'
        ),
        'sandboxMode' => array
            (
            'FriendlyName' => 'Test Mode',
            'Type' => 'yesno'
        ),
        'debug' => array
            (
            'FriendlyName' => 'Debug Mode',
            'Type' => 'yesno',
            "Description" => "Logs on \"Module Log\"",
        ),
        'adminContact' => array
            (
            'FriendlyName' => 'Admin Contact',
            'Type' => 'yesno',
            "Description" => "Specify that the owner will be OwnerC and AdminC and reseller will be Billing/TechC",
        ),
    );

    return $configArray;
}

/**
 * FUNCTION InterNetX_RegisterDomain
 * This function is called when the registration of a new domain is requested from WHMCS
 * @param array $params
 * @return array $return
 */
function InterNetX_RegisterDomain($params)
{
    try {
        $API = new InterNetX_API($params['serverHost'], $params['serverUsername'], $params['serverPassword'], $params['serverContext'], $params['sandboxServerUsername'], $params['sandboxServerPassword'], $params['sandboxServerContext'], $params['debug'], $params['sandboxMode']);
        $API->setReplyTo($params['replyTo']);
        # Contacts check
        $contacts = new stdClass();
        $contacts->ownerc = "";
        $contacts->adminc = "";
        $contacts->techc = "";
        $contacts->zonec = "";

        $extensions = InterNetX_Extension::assing($params['tld'], $params['additionalfields']);

        foreach ($contacts as $key => $contact) {
            if($params['adminContact'] == 'on')
            {
                if($key == "ownerc" || $key == "adminc")
                {
                    $type = null;
                }else{
                    $type = "admin";
                }
            }else{
                $type = ($key == "ownerc") ? null : "admin";
            }

            if (!empty($params[$type . 'address1']) && !empty($params[$type . 'address2']))
                $address = $params[$type . 'address1'] . " " . $params[$type . 'address2'];
            else
                $address = $params[$type . 'address1'];

            $user = array(
                'id' => $contact,
                'type' => ($params[$type.'companyname'] == "") ? "PERSON" : "ORG",
                'firstName' => $params[$type . 'firstname'],
                'lastName' => $params[$type . 'lastname'],
                'organization' => $params[$type . 'companyname'],
                'address' => $address,
                'city' => $params[$type . 'city'],
                'state' => $params[$type . 'state'],
                'postCode' => $params[$type . 'postcode'],
                'country' => $params[$type . 'country'],
                'countryName' => $params[$type . 'countryname'],
                'phone' => InterNetX_FormatPhone($params[$type . 'fullphonenumber']),
                //'fax' => InterNetX_FormatPhone($params[$type . 'fullphonenumber']),
                'email' => $params[$type . 'email'],
            );

            if ($key != "ownerc" && ($params['tld'] == "de" || $params['tld'] == "es")) {
                $user['type'] = "PERSON";
            }

            $result = $API->contactCreate($user, $extensions);
            if ($API->hasError()) {
                $err = $API->getErrors();
                foreach ($contacts as $key2 => $contact_id)
                    $API->contactDelete($contact_id, $params['email']);

                return array("error" => "Contact create error: {$err}");
            }
            $contacts->$key = (string) $result->result->status->object->value;
            $API->contactInfo($contacts->$key);
        }
        # Create domain
        $ns = array();
        $ip = 1;
        if ($params['sandboxMode'] == "on") {
            $zoneNs = explode("\n", trim($params['sandboxNameServers']));
        } else{
            $zoneNs = explode("\n", trim($params['nameServers']));
        }
        $ns = array();
        for ($i = 1; $i < 6; $i++) {
            if ($params['ns' . $i] == '')
                continue;
            $nameServer = array();
            $nameServer = explode(" ", preg_replace('/\s+/', ' ', $params['ns' . $i]));
            $ns[] = array(
                'name' => $nameServer[0],
                'ip' => $nameServer[1],
                'ip6' => $nameServer[2]
            );
        }
        $domainIP = $params['domainIP'];
        $domainMX = $params['domainMX'];
        if (isset($params['original']))
            $params = $params['original'];

        $idna_convert = new idna_convert();
        $domain = $idna_convert->encode($params['sld'] . '.' . $params['tld']);

//        $API->zoneCreate($domain, $zoneNs);
//        if ($API->hasError()) {
//            $err = $API->getErrors();
//            foreach ($contacts as $key2 => $contact_id)
//                $API->contactDelete($contact_id, $params['email']);
//
//            return array("error" => "Zone create error: {$err}");
//        }

        //check if premium domains addon and Lookup Provider are set
        $lookupProvider = Capsule::table('tblconfiguration')->select('value')->where('setting', '=', 'domainLookupRegistrar')->first();
        $isAddonActive  = Capsule::table('tbladdonmodules')->select('value')->where('module', '=', 'InterNetX')->exists();
//        $isPremiumDomainsOn = Capsule::table('tblconfiguration')->select('value')->where('setting', '=', 'PremiumDomains')->value();
	$isPremiumDomainsOn = Capsule::table('tblconfiguration')->where('setting', '=', 'PremiumDomains')->value('value');

        //check if domain is premium
        $isPremium = $API->checkPremiumAvability($domain, $action);

        if($isPremium !== false && $lookupProvider->value == 'InterNetX' && $isAddonActive && $isPremiumDomainsOn == '1')
        {
            $className = (string) $isPremium->result->data->domain_premium->price_class;
            $API->premiumDomainCreate($domain, $params['regperiod'], (array) $contacts, $ns, $params['idprotection'], $domainIP, $domainMX, $className);
        }else if($isPremium === false){
            $API->domainCreate($domain, $params['regperiod'], (array) $contacts, $ns, $params['idprotection'], $domainIP, $domainMX);
        }else{
            return array("error" => 'Cannot register domain. Please be sure that your Premium Domains addon module is active and configured correctly.');
        }

        \WHMCS\Session::delete("premiumDomainPricingClass");
        if ($API->hasError() && $isPremium != false) {
            $err = $API->getErrors();
            foreach ($contacts as $key2 => $contact_id)
                $API->contactDelete($contact_id, $params['email']);
            return array("error" => $err);
        }
    } catch (Exception $ex) {
        return array("error" => $ex->getMessage());
    }
}

/**
 * FUNCTION InterNetX_RenewDomain
 * This function is called when an existing domain is requested for renewal within WHMCS
 * @param array $params
 * @return array $return
 */

function InterNetX_RenewDomain($params)
{
    try {
        $API = new InterNetX_API($params['serverHost'], $params['serverUsername'], $params['serverPassword'], $params['serverContext'], $params['sandboxServerUsername'], $params['sandboxServerPassword'], $params['sandboxServerContext'], $params['debug'], $params['sandboxMode']);
        $API->setReplyTo($params['replyTo']);
        if (isset($params['original']))
            $params = $params['original'];

        $idna_convert = new idna_convert();
        $domain = $idna_convert->encode($params['sld'] . '.' . $params['tld']);
        $info = $API->domainInfo($domain);

        if (!$info)
            return $API->hasError() ? array("error" => $API->getErrors()) : array(
                "error" => "Unable to get domain info");

        if($params['autodelete'] != 'on')
        {
            if (strpos($_SERVER['PHP_SELF'], 'clientsdomains.php') == false)
            {
                return true;
            }
        }
/****ERROR:
the API call is always sent. the above check for autodelete
only prevents the check for being on the backend page but does not prevent the renewal
so the domain would always be renewed
except that all manual renewals generate this error:
EF0072003 - The registry does not support this operation.
*/

        $exp_date = (string) $info->result->data->domain->payable;
        $exp_date = date("Y-m-d", strtotime($exp_date));
        $API->domainRenew($domain, $exp_date, $params['regperiod']);

        if ($API->hasError())
            return array("error" => $API->getErrors());
    } catch (Exception $ex) {
        return array("error" => $ex->getMessage());
    }
}

/**
 * FUNCTION InterNetX_TransferDomain
 * Transfer of domain name from one registrar to another
 * @param array $params
 * @return array $return
 */
function InterNetX_TransferDomain($params)
{
    try {
        $API = new InterNetX_API($params['serverHost'], $params['serverUsername'], $params['serverPassword'], $params['serverContext'], $params['sandboxServerUsername'], $params['sandboxServerPassword'], $params['sandboxServerContext'], $params['debug'], $params['sandboxMode']);
        $API->setReplyTo($params['replyTo']);
        $eppCode = $params['eppcode'];
        $domainIP = $params['domainIP'];
        $domainMX = $params['domainMX'];

		$extensions = InterNetX_Extension::assing($params['tld'], $params['additionalfields']);

        if (isset($params['original']))
            $params = $params['original'];



        $idna_convert = new idna_convert();
        $domain = $idna_convert->encode($params['sld'] . '.' . $params['tld']);

        # Contacts check
        $contacts = new stdClass();
        $contacts->ownerc = "";
        $contacts->adminc = "";
        $contacts->techc = "";
        $contacts->zonec = "";

        foreach ($contacts as $key => $contact) {
            if($params['adminContact'] == 'on')
            {
                if($key == "ownerc" || $key == "adminc")
                {
                    $type = null;
                }else{
                    $type = "admin";
                }
            }else{
                $type = ($key == "ownerc") ? null : "admin";
            }

            if (!empty($params[$type . 'address1']) && !empty($params[$type . 'address2']))
                $address = $params[$type . 'address1'] . " " . $params[$type . 'address2'];
            else
                $address = $params[$type . 'address1'];

            $user = array(
                'id' => $contact,
                'type' => ($params[$type.'companyname'] == "") ? "PERSON" : "ORG",
                'firstName' => $params[$type . 'firstname'],
                'lastName' => $params[$type . 'lastname'],
                'organization' => $params[$type . 'companyname'],
                'address' => $address,
                'city' => $params[$type . 'city'],
                'state' => $params[$type . 'state'],
                'postCode' => $params[$type . 'postcode'],
                'country' => $params[$type . 'country'],
                'countryName' => $params[$type . 'countryname'],
                'phone' => InterNetX_FormatPhone($params[$type . 'fullphonenumber']),
                //'fax' => InterNetX_FormatPhone($params[$type . 'fullphonenumber']),
                'email' => $params[$type . 'email'],
            );

            if ($key != "ownerc" && ($params['tld'] == "de" || $params['tld'] == "es")){
                $user['type'] = "PERSON";
            }

            $result = $API->contactCreate($user, $extensions);
            if ($API->hasError()) {
                $err = $API->getErrors();
                foreach ($contacts as $key2 => $contact_id)
                    $API->contactDelete($contact_id, $params['email']);

                return array("error" => "Contact create error: {$err}");
            }
            $contacts->$key = (string) $result->result->status->object->value;
            $API->contactInfo($contacts->$key);
        }
        # Create domain
        $ns = array();
        for ($i = 1; $i < 6; $i++) {
            if ($params['ns' . $i] == '')
                continue;
            $nameServer = array();
            $nameServer = explode(" ", preg_replace('/\s+/', ' ', $params['ns' . $i]));
            $ns[] = array(
                'name' => $nameServer[0],
                'ip' => $nameServer[1],
                'ip6' => $nameServer[2]
            );
        }

        $API->transferIn($domain, (array) $contacts, $ns, $eppCode, $params['idprotection'], $domainIP, $domainMX);

        if ($API->hasError()) {
            $err = $API->getErrors();
            foreach ($contacts as $key2 => $contact_id)
                $API->contactDelete($contact_id, $params['email']);
            return array("error" => $err);
        }

        #Create Zone
//        $i      = 1;
//        $zoneNS = array();
//
//        while (!empty($params['ns' . $i])) {
//            $zoneNS[] = $params['ns' . $i];
//            $i++;
//        }
//
//        $API->zoneCreate($domain, $zoneNS);
//        if ($API->hasError()) {
//            $err = $API->getErrors();
//            foreach ($contacts as $key2 => $contact_id)
//                    $API->contactDelete($contact_id, $params['email']);
//
//            return array("error" => "Zone create error: {$err}");
//        }
    } catch (Exception $ex) {
        return array("error" => $ex->getMessage());
    }
}


/**
 * FUNCTION InterNetX_GetNameservers
 * This function is called whenever a domains details are requested/viewed within WHMCS.
 * It can return up to 5 nameservers that are set for the domain.
 * @param array $params
 * @return array $values
 */
function InterNetX_GetNameservers($params)
{
    try {
        $API = new InterNetX_API($params['serverHost'], $params['serverUsername'], $params['serverPassword'], $params['serverContext'], $params['sandboxServerUsername'], $params['sandboxServerPassword'], $params['sandboxServerContext'], $params['debug'], $params['sandboxMode']);
        $API->setReplyTo($params['replyTo']);
        if (isset($params['original']))
            $params = $params['original'];

        $idna_convert = new idna_convert();
        $domain = $idna_convert->encode($params['sld'] . '.' . $params['tld']);

        $info = $API->domainInfo($domain);
        if (!$info)
            return $API->hasError() ? array("error" => $API->getErrors()) : array(
                "error" => "Unable  to get Nameservers");

        $dns = $info->result->data->domain->nserver;
        $id = 1;
        $values = array();
        foreach ($dns as $ns) {
            $nameserver = array();
            if (!empty($ns->name))
                $nameserver[] = $ns->name;
            if (!empty($ns->ip))
                $nameserver[] = $ns->ip;
            if (!empty($ns->ip6))
                $nameserver[] = $ns->ip6;

            $values['ns' . (string) $id++] = (string) implode(" ", $nameserver);
        }

        return $values;
    } catch (Exception $ex) {
        return array("error" => $ex->getMessage());
    }
}

/**
 * FUNCTION InterNetX_SaveNameservers
 * This function is called when a change is made to the nameserver values displayed inside WHMCS.
 * @param array $params
 * @return array $return
 */
function InterNetX_SaveNameservers($params)
{

    try {

        $API = new InterNetX_API($params['serverHost'], $params['serverUsername'], $params['serverPassword'], $params['serverContext'], $params['sandboxServerUsername'], $params['sandboxServerPassword'], $params['sandboxServerContext'], $params['debug'], $params['sandboxMode']);
        $API->setReplyTo($params['replyTo']);
        if (isset($params['original']))
            $params = $params['original'];

        $idna_convert = new idna_convert();
        $domain = $idna_convert->encode($params['sld'] . '.' . $params['tld']);

        $info = $API->domainInfo($domain);
        if (!$info)
            return $API->hasError() ? array("error" => $API->getLastError()) : array(
                "error" => "Unable  to get Nameservers");


        $ns = array();
        for ($i = 1; $i < 6; $i++) {
            if ($params['ns' . $i] == '')
                continue;
            $nameServer = array();
            $nameServer = explode(" ", preg_replace('/\s+/', ' ', $params['ns' . $i]));
            $ns[] = array(
                'name' => $nameServer[0],
                'ip' => $nameServer[1],
                'ip6' => $nameServer[2]
            );
        }
        $client = internetx_getClientDetails($params['domainid']);

        $domianInfo = (array) $info->result->data->domain;
        $infoNameservers = $domianInfo['nserver'];
        foreach ($infoNameservers as $key => $value) {
            $testTable[] = (array) $value;
        }
        $result = $testTable == $ns;

        if (count($ns) && !$result) {
            $result = $API->domainUpdate($domain, array(), $ns, $client['email']);
            if ($API->hasError())
                return array("error" => $API->getErrors());
        }
    } catch (Exception $ex) {
        return array("error" => $ex->getMessage());
    }
}

/**
 * FUNCTION InterNetX_GetDNS
 * This function is called when the DNS Host Records are requested to be viewed within WHMCS
 * @param array $params
 * @return array $return
 */
function InterNetX_GetDNS($params)
{

    try {
        $API = new InterNetX_API($params['serverHost'], $params['serverUsername'], $params['serverPassword'], $params['serverContext'], $params['sandboxServerUsername'], $params['sandboxServerPassword'], $params['sandboxServerContext'], $params['debug'], $params['sandboxMode']);
        $API->setReplyTo($params['replyTo']);
        if (isset($params['original']))
            $params = $params['original'];

        $idna_convert = new idna_convert();
        $domain = $idna_convert->encode($params['sld'] . '.' . $params['tld']);

        $info = $API->zoneInfo($domain);

        if ($API->hasError()) {
            $err = $API->getErrors();

            if (strpos($err, "E0205") !== false) {

                if ($params['sandboxMode'] == "on") {
                    $zoneNs = explode("\n", trim($params['sandboxNameServers']));
                } else
                    $zoneNs = explode("\n", trim($params['nameServers']));

                $zoneNs = array_unique($zoneNs);
                foreach ($zoneNs as $k => $n) {
                    $zoneNs[$k] = trim($n);
                }
                $API->zoneCreate($domain, $zoneNs);

                if ($API->hasError())
                    return array("error" => $API->getErrors());
            }else {
                return array("error" => $err);
            }
        }
        $zone = (array) $info->result->data->zone;
        $records = array();
        $info = $API->zoneInfo($domain);
        foreach ($info->result->data->zone->rr as $rr) {
            $records[] = array(
                "hostname" => (string) $rr->name,
                "type" => (string) $rr->type,
                "address" => htmlspecialchars((string) $rr->value),
                "priority" => (string) $rr->pref,
            );
        }
        global $smarty;
        $smarty->assign("zone", $info->result->data->zone);
        return $records;
    } catch (Exception $ex) {
        return array("error" => $ex->getMessage());
    }
}

/**
 * FUNCTION InterNetX_SaveDNS
 * This function is called when any changes to DNS Host Records information is submitted
 * @param array $params
 * @return array $return
 */
function InterNetX_SaveDNS($params)
{

    try {
        $API = new InterNetX_API($params['serverHost'], $params['serverUsername'], $params['serverPassword'], $params['serverContext'], $params['sandboxServerUsername'], $params['sandboxServerPassword'], $params['sandboxServerContext'], $params['debug'], $params['sandboxMode']);
        $API->setReplyTo($params['replyTo']);
        if (isset($params['original']))
            $params = $params['original'];


        $idna_convert = new idna_convert();
        $domain = $idna_convert->encode($params['sld'] . '.' . $params['tld']);
        if ($params['sandboxMode'] == "on") {
            $zoneNs = explode("\n", trim($params['sandboxNameServers']));
        } else
            $zoneNs = explode("\n", trim($params['nameServers']));

        $zoneNs = array_unique($zoneNs);
        $info = $API->zoneInfo($domain);
        if ($API->hasError())
            return array("error" => $API->getErrors());

        $dnsOld = array();
        $info = $API->zoneInfo($domain);
        foreach ($info->result->data->zone->rr as $rr) {
            $dnsOld[] = array(
                "hostname" => (string) $rr->name,
                "type" => (string) $rr->type,
                "address" => (string) $rr->value,
                "priority" => (string) $rr->pref,
            );
        }
        $dnsRecords = $params['dnsrecords'];
        $records = array();
        $notSuported = array("MXE", "URL", "FRAME");
        foreach ($dnsRecords as $k => $r) {
            if (empty($r['hostname']) && empty($r['address']))
                continue;

            if (in_array($r['type'], $notSuported))
                return array("error" => "Record \"{$r['type']}\" is not supported");

            $records[] = array(
                "name" => $r['hostname'],
                "type" => $r['type'],
                "value" => $r['address'],
                "pref" => $r['priority'] == "N/A" ? "" : $r['priority'],
            );
        }

        $mainIP = $_REQUEST['zone']['main']['value'];
        $www_include = (int) $_REQUEST['zone']['www_include'];
        $API->zoneUpdate($domain, $zoneNs, $records, $mainIP, $www_include);
        if ($API->hasError())
            return array("error" => $API->getErrors());
    } catch (Exception $ex) {
        return array("error" => $ex->getMessage());
    }
}

/**
 * FUNCTION InterNetX_GetContactDetails
 * This function is called when the WHOIS information is requested to be viewed
 * @param array $params
 * @return array $values
 */
function InterNetX_GetContactDetails($params)
{

    try {
        $API = new InterNetX_API($params['serverHost'], $params['serverUsername'], $params['serverPassword'], $params['serverContext'], $params['sandboxServerUsername'], $params['sandboxServerPassword'], $params['sandboxServerContext'], $params['debug'], $params['sandboxMode']);
        $API->setReplyTo($params['replyTo']);

        if (isset($params['original']))
            $params = $params['original'];

        $idna_convert = new idna_convert();
        $domain = $idna_convert->encode($params['sld'] . '.' . $params['tld']);

        $info = $API->domainInfo($domain);
        if (!$info)
            return $API->hasError() ? array("error" => $API->getLastError()) : array(
                "error" => "Unable  to get domain info");

        $contactsIds = array(
            'Registrant' => (string) $info->result->data->domain->ownerc,
            'Admin' => (string) $info->result->data->domain->adminc,
            'Tech' => (string) $info->result->data->domain->techc,
            'Zone' => (string) $info->result->data->domain->zonec,
        );
        $contactsIds = array_unique($contactsIds);

        $values = array();
        foreach ($contactsIds as $key => $id) {
            $cont = $API->contactInfo($id);
            if ($API->hasError())
                return array("error" => $API->getErrors());
            $handle = $cont->result->data->handle;
            $values[$key]['Handle ID'] = (string) $id;
            $values[$key]['First Name'] = (string) $handle->fname;
            $values[$key]['Last Name'] = (string) $handle->lname;
            $values[$key]['Company Name'] = (string) $handle->organization;
            $values[$key]['City'] = (string) $handle->city;
            $values[$key]['Address'] = (string) $handle->address;
            $values[$key]['State'] = (string) $handle->state;
            $values[$key]['Postcode'] = (string) $handle->pcode;
            $values[$key]['Country'] = (string) $handle->country;
            $values[$key]['Phone Number'] = (string) $handle->phone;
            $values[$key]['Email'] = (string) $handle->email;
        }
        return $values;
    } catch (Exception $ex) {
        return array("error" => $ex->getMessage());
    }
}

/**
 * FUNCTION InterNetX_SaveContactDetails
 * This function is called when revised WHOIS information is submitted
 * @param array $params
 * @return array $errormsg
 */
function InterNetX_SaveContactDetails($params)
{

    try {
        $API = new InterNetX_API($params['serverHost'], $params['serverUsername'], $params['serverPassword'], $params['serverContext'], $params['sandboxServerUsername'], $params['sandboxServerPassword'], $params['sandboxServerContext'], $params['debug'], $params['sandboxMode']);
        $API->setReplyTo($params['replyTo']);

$passedParams = $params;

        if (isset($params['original']))
            $params = $params['original'];

// Re-Add ContactDetails if necessary
		if (!isset($params['contactdetails'])){
			if (isset($passedParams['contactdetails'])){
				$params['contactdetails'] = $passedParams['contactdetails'];
			    }
}

        $idna_convert = new idna_convert();
        $domain = $idna_convert->encode($params['sld'] . '.' . $params['tld']);

        $info = $API->domainInfo($domain);
        if (!$info)
            return $API->hasError() ? array("error" => $API->getLastError()) : array(
                "error" => "Unable  to get domain info");

        $contactsIds = array(
            'Registrant' => (string) $info->result->data->domain->ownerc,
            'Admin' => (string) $info->result->data->domain->adminc,
            'Tech' => (string) $info->result->data->domain->techc,
            'Zone' => (string) $info->result->data->domain->zonec,
        );
        $contactsIds = array_unique($contactsIds);

        $values = array();
        foreach ($contactsIds as $key => $id) {

            $contact = $params['contactdetails'][$key];
            if (!empty($contact['Address 1']) && !empty($contact['Address 2']))
                $address = $contact['Address 1'] . " " . $contact['Address 2'];
            else if (isset($contact['Address 1']) && !isset($contact['Address 2']))
                $address = $contact['Address 1'];
            else
                $address = $contact['Address'];

            $user = array(
                'id' => $id,
                'firstName' => $contact['First Name'],
                'lastName' => $contact['Last Name'],
                'organization' => $contact['Company Name'],
                'address' => $address,
                'city' => $contact['City'],
                'state' => $contact['State'],
                'postCode' => $contact['Postcode'],
                'country' => $contact['Country'],
                'phone' => str_replace(".", "-", $contact['Phone Number']),
                'email' => $contact['Email'],
            );

            $API->contactUpdate($user);

            if ($API->hasError())
                return array("error" => $API->getErrors());
        }
        return $values;
    } catch (Exception $ex) {
        return array("error" => $ex->getMessage());
    }
}

/**
 * FUNCTION InterNetX_GetEPPCode
 * This function is called when the EPP Code is requested for a transfer out.
 * @param array $params
 * @return array $errormsg
 */
function InterNetX_GetEPPCode($params)
{
    try {
        $API = new InterNetX_API($params['serverHost'], $params['serverUsername'], $params['serverPassword'], $params['serverContext'], $params['sandboxServerUsername'], $params['sandboxServerPassword'], $params['sandboxServerContext'], $params['debug'], $params['sandboxMode']);
        $API->setReplyTo($params['replyTo']);
        if (isset($params['original']))
            $params = $params['original'];

        $idna_convert = new idna_convert();
        $domain = $idna_convert->encode($params['sld'] . '.' . $params['tld']);

        $API->domainUpdateStatus($domain);
        if (strpos($params['tld'], 'de') !== false || strpos($params['tld'], 'eu') !== false) {
            $API->authinfo1Create($domain);
        }
        $API->getErrors();

        $info = $API->domainInfo($domain);
        if (!$info)
            return $API->hasError() ? array("error" => $API->getLastError()) : array(
                "error" => "Unable  to get domain info");

        $values["eppcode"] = $info->result->data->domain->authinfo;

        return $values;
    } catch (Exception $ex) {
        return array("error" => $ex->getMessage());
    }
}

/**
 * FUNCTION InterNetX_Sync
 * This function is called for every domain in the Active status each time your domain sync cron runs.
 * @param array $params
 * @return array $return
 */
function InterNetX_Sync($params)
{
    try {
        $API = new InterNetX_API($params['serverHost'], $params['serverUsername'], $params['serverPassword'], $params['serverContext'], $params['sandboxServerUsername'], $params['sandboxServerPassword'], $params['sandboxServerContext'], $params['debug'], $params['sandboxMode']);
        if (isset($params['original']))
            $params = $params['original'];

        $idna_convert = new idna_convert();
        $domain = $idna_convert->encode($params['sld'] . '.' . $params['tld']);

        $info = $API->domainInfoSubUser($domain);

        if ($API->hasError()) {
            $errors = $API->getErrors();
            logModuleCall(
                "InterNetX", 'Hello From InterNetX_Sync', 'if ($API->hasError()) {$errors = $API->getErrors();', '', $errors, array()
            );
            if (strpos($errors, "EF01012") !== false) {
                return array("expired" => 1);
            }

            // E0105 – Domain data could not be inquired. alternativ EF0412
            if (strpos($errors, "E0105") !== false) {
                logModuleCall(
                    "InterNetX", 'Hello From InterNetX_Sync',' if (strpos($errors, "E0105") !== false) {', '', '', array()
                );
                $values = array();
                // Testweise ohne active, sonst unkommentieren
                // $values['active'] = false;
                $values['cancelled'] = true;
                return $values;
            }

            return array("error" => $errors);
        }
        $values = array();
        if ($info) {
            if (strtolower(strtolower($info->result->data->domain->status)) == "success") {
                // fix transfer
                if ((string) $info->result->data->domain->payable == "0000-00-00 00:00:00" || (string) $info->result->data->domain->payable == "0000-00-00" || !isset($info->result->data->domain->payable))
                    return;
                $values['active'] = true;
                $expiry_date = date('Y-m-d', strtotime((string) $info->result->data->domain->payable));
                $values['expirydate'] = (string) $expiry_date;

                if (strtotime($expiry_date) < strtotime(date('Y-m-d'))) {
                    $values['active'] = false;
                    $values['cancelled'] = true;
                }
            } else {
                $values['cancelled'] = true;
            }
        } else {
            $values['expired'] = true;
        }
        return $values;
    } catch (Exception $ex) {
        return array("error" => $ex->getMessage());
    }
}

/**
 * FUNCTION InterNetX_TransferSync
 * This function is called for every domain in the Pending Transfer status each time your domain sync cron runs.
 * @param array $params
 * @return array $return
 */
function InterNetX_TransferSync($params)
{

    try {
        $API = new InterNetX_API($params['serverHost'], $params['serverUsername'], $params['serverPassword'], $params['serverContext'], $params['sandboxServerUsername'], $params['sandboxServerPassword'], $params['sandboxServerContext'], $params['debug'], $params['sandboxMode']);
        $API->setReplyTo($params['replyTo']);
        if (isset($params['original']))
            $params = $params['original'];

        $idna_convert = new idna_convert();
        $domain = $idna_convert->encode($params['sld'] . '.' . $params['tld']);

        $info = $API->domainInfo($domain);
        if ($API->hasError()) {
            return array("error" => $API->getErrors());
        }
        $values = array();
        if ($info) {
            if (strtolower(strtolower($info->result->data->domain->status)) == "success") {

                // fix transfer
                if ((string) $info->result->data->domain->payable == "0000-00-00 00:00:00" || (string) $info->result->data->domain->payable == "0000-00-00" || !isset($info->result->data->domain->payable))
                    return;
                $values['active'] = true;
                $expiry_date = date('Y-m-d', strtotime((string) $info->result->data->domain->payable));
                $values['expirydate'] = (string) $expiry_date;

                if (empty($info->result->data->domain->authinfo))
                    $values['completed'] = true;
            }
        }
        return $values;
    } catch (Exception $ex) {
        return array("error" => $ex->getMessage());
    }
}

/**
 * FUNCTION InterNetX_IDProtectToggle
 * This function is called when the ID Protection setting is toggled on or off.
 * @param array $params
 * @return array $return
 */
function InterNetX_IDProtectToggle($params)
{

    try {

        $API = new InterNetX_API($params['serverHost'], $params['serverUsername'], $params['serverPassword'], $params['serverContext'], $params['sandboxServerUsername'], $params['sandboxServerPassword'], $params['sandboxServerContext'], $params['debug'], $params['sandboxMode']);
        $API->setReplyTo($params['replyTo']);
        if (isset($params['original']))
            $params = $params['original'];

        $values = array();
        $idna_convert = new idna_convert();
        $domain = $idna_convert->encode($params['sld'] . '.' . $params['tld']);

        $client = internetx_getClientDetails($params['domainid']);
        //On
        if ($params['protectenable'] == 1) {
            $API->domainUpdateIDProtection($domain, "true", $client['email']);
            //off
        } else {
            $API->domainUpdateIDProtection($domain, "false", $client['email']);
        }

        if ($API->hasError())
        {
            return array("error" => $API->getErrors());
        }
    } catch (Exception $ex) {
        return array("error" => $ex->getMessage());
    }
}

/**
 * FUNCTION InterNetX_GetEmailForwarding
 * This function is called when the Email Forwarding are requested to be viewed within WHMCS
 * @param array $params
 * @return array $return
 */
function InterNetX_GetEmailForwarding($params)
{

    try {
        $API = new InterNetX_API($params['serverHost'], $params['serverUsername'], $params['serverPassword'], $params['serverContext'], $params['sandboxServerUsername'], $params['sandboxServerPassword'], $params['sandboxServerContext'], $params['debug'], $params['sandboxMode']);
        $API->setReplyTo($params['replyTo']);
        if (isset($params['original']))
            $params = $params['original'];

        $values = array();
        $idna_convert = new idna_convert();
        $domain = $idna_convert->encode($params['sld'] . '.' . $params['tld']);
        $redirect = $API->redirectInfo($domain);
        if ($API->hasError())
            return array("error" => $API->getErrors());

        $values = array();
        foreach ($redirect->result->data->redirect as $key => $rd) {
            if ($rd->mode != "single")
                continue;
            $surce = current(explode("@", (string) $rd->source));
            $values[] = array(
                "recid" => $key,
                "prefix" => $surce,
                "forwardto" => (string) $rd->target,
            );
        }
        return $values;
    } catch (Exception $ex) {
        return array("error" => $ex->getMessage());
    }
}

/**
 * FUNCTION InterNetX_SaveEmailForwarding
 * This function is called when any changes to Email Forwardin information is submitted
 * @param array $params
 * @return array $return
 */
function InterNetX_SaveEmailForwarding($params)
{

    try {
        $API = new InterNetX_API($params['serverHost'], $params['serverUsername'], $params['serverPassword'], $params['serverContext'], $params['sandboxServerUsername'], $params['sandboxServerPassword'], $params['sandboxServerContext'], $params['debug'], $params['sandboxMode']);
        $API->setReplyTo($params['replyTo']);
        if (isset($params['original']))
            $params = $params['original'];

        $values = array();
        $idna_convert = new idna_convert();
        $domain = $idna_convert->encode($params['sld'] . '.' . $params['tld']);

        $new = array();
        foreach ($params['prefix'] as $key => $value) {
            if (is_array($value)) {
                $new[] = array(
                    "prefix" => $value[0],
                    "forwardto" => $params['forwardto'][$key][0],
                );
            } else {
                $new[] = array(
                    "prefix" => $value,
                    "forwardto" => $params['forwardto'][$key],
                );
            }
        }

        $redirect = $API->redirectInfo($domain);
        if ($API->hasError())
            return array("error" => $API->getErrors());

        $old = array();
        foreach ($redirect->result->data->redirect as $key => $rd) {
            if ($rd->mode != "single")
                continue;
            $surce = current(explode("@", (string) $rd->source));
            $old[] = array(
                "prefix" => $surce,
                "forwardto" => (string) $rd->target,
            );
        }

        foreach ($new as $k => $v) {

            //remove dns record
            if ((empty($v['prefix']) || empty($v['forwardto'])) && isset($old[$k]['prefix'])) {
                $surce = $old[$k]['prefix'] . "@" . $domain;
                $API->redirectDelete($surce, "email");
                if ($API->hasError())
                    return array("error" => $API->getErrors());

                //edit dns records  only forwardto
            }else if (($v['prefix'] != $old[$k]['prefix']) && isset($old[$k]['prefix'])) {
                $surce = $old[$k]['prefix'] . "@" . $domain;
                $API->redirectDelete($surce, "email");

                $API->redirectCreateEmail($v["prefix"] . "@" . $domain, $v["forwardto"]);
                if ($API->hasError())
                    return array("error" => $API->getErrors());

                //remove dns record  adn create new
            }else if (($v['prefix'] == $old[$k]['prefix'] && $v['forwardto'] != $old[$k]['forwardto']) && isset($old[$k]['prefix'])) {
                $source = $v['prefix'] . "@" . $domain;
                $target = $v['forwardto'];
                $API->redirectUpdateEmail($source, $target);
                if ($API->hasError())
                    return array("error" => $API->getErrors());
            }
        }
        //adding new record
        $lastKeyNew = count($new) - 1;
        if (!empty($new[$lastKeyNew]["prefix"]) && !isset($old[$lastKeyNew]["prefix"])) {
            $API->redirectCreateEmail($new[$lastKeyNew]["prefix"] . "@" . $domain, $new[$lastKeyNew]["forwardto"]);
            if ($API->hasError())
                return array("error" => $API->getErrors());
        }
    } catch (Exception $ex) {
        return array("error" => $ex->getMessage());
    }
}

/**
 * FUNCTION InterNetX_AdminCustomButtonArray
 * This function can be used to define admin functions.
 * @param type $params
 * @return string
 */
function InterNetX_AdminCustomButtonArray()
{

    $buttonArray = array(
        "Transfer Out ACK" => "transferOutAck",
        "Transfer Out NACK" => "transferOutNack",
    );
    return $buttonArray;
}

/**
 * FUNCTION InterNetX_AdminCustomButtonArray
 * Transfer out domain ACK
 * @param type $params
 * @return string
 */
function InterNetX_transferOutAck($params)
{
    try {
        $API = new InterNetX_API($params['serverHost'], $params['serverUsername'], $params['serverPassword'], $params['serverContext'], $params['sandboxServerUsername'], $params['sandboxServerPassword'], $params['sandboxServerContext'], $params['debug'], $params['sandboxMode']);
        $API->setReplyTo($params['replyTo']);
        if (isset($params['original']))
            $params = $params['original'];

        $idna_convert = new idna_convert();
        $domain = $idna_convert->encode($params['sld'] . '.' . $params['tld']);
        $result = $API->transferOut($domain, "ack");
        if ($API->hasError())
            return array("error" => $API->getErrors());
    } catch (Exception $ex) {
        return array("error" => $ex->getMessage());
    }
}

/**
 * FUNCTION InterNetX_AdminCustomButtonArray
 * Transfer out domain NACK
 * @param type $params
 * @return string
 */
function InterNetX_transferOutNack($params)
{

    try {
        $API = new InterNetX_API($params['serverHost'], $params['serverUsername'], $params['serverPassword'], $params['serverContext'], $params['sandboxServerUsername'], $params['sandboxServerPassword'], $params['sandboxServerContext'], $params['debug'], $params['sandboxMode']);
        $API->setReplyTo($params['replyTo']);
        if (isset($params['original']))
            $params = $params['original'];

        $idna_convert = new idna_convert();
        $domain = $idna_convert->encode($params['sld'] . '.' . $params['tld']);

        $result = $API->transferOut($domain, "nack");
        if ($API->hasError())
            return array("error" => $API->getErrors());
    } catch (Exception $ex) {
        return array("error" => $ex->getMessage());
    }
}

/**
 * FUNCTION proxmoxVPS_ClientAreaCustomButtonArray
 * This function used to define custom functions for client area
 * @param array $params
 * @return array
 */
function InterNetX_ClientAreaCustomButtonArray($params)
{
    return array(
        'Domain Redirect' => 'domainForwarding',
        'Owner Change' => 'changeOwner',
    );
}

/**
 * FUNCTION InterNetX_domainForwarding
 * Manage domain forwarding in client area
 * @param array $params
 * @return array $return
 */
function InterNetX_domainForwarding($params)
{

    try {

        $API = new InterNetX_API($params['serverHost'], $params['serverUsername'], $params['serverPassword'], $params['serverContext'], $params['sandboxServerUsername'], $params['sandboxServerPassword'], $params['sandboxServerContext'], $params['debug'], $params['sandboxMode']);
        $API->setReplyTo($params['replyTo']);
        if (isset($params['original']))
            $params = $params['original'];

        $idna_convert = new idna_convert();
        $domain = $idna_convert->encode($params['sld'] . '.' . $params['tld']);
        $errors = array();


        if (!empty($_POST)) {

            $domainForwarding = $_POST['domainForwarding'];
            foreach ($domainForwarding as $k => $df) {

                $id = $df['id'];
                $source = $df['source'];
                $sourceDomain = "{$source}.{$domain}";
                $target = $df['target'];

                //delete
                if (empty($df['source']) || empty($target)) {
                    $API->redirectDelete($id, "domain");
                    if ($API->hasError())
                        $errors[] = $API->getErrors();
                    //update
                }else if ($sourceDomain == $id) {
                    $API->updateDomainRedirect($df['source'], $target, $df['mode'], $df['title']);
                    if ($API->hasError())
                        $errors[] = $API->getErrors();

                    //delete and create new
                }else {
                    $API->redirectDelete($id, "domain");
                    $API->createDomainRedirect($df['source'], $target, $df['mode'], $df['title']);
                    if ($API->hasError())
                        $errors[] = $API->getErrors();
                }
            }

            //adding new
            $newDomainForwarding = $_POST['newDomainForwarding'];
            if (!empty($newDomainForwarding['source']) && !empty($newDomainForwarding['target'])) {
                $source = $newDomainForwarding['source'] . ".{$domain}";
                $API->createDomainRedirect($newDomainForwarding['source'], $newDomainForwarding['target'], $newDomainForwarding['mode'], $newDomainForwarding['title']);
                if ($API->hasError())
                    $errors[] = $API->getErrors();
            }
        }
        $result = $API->redirectInfo($domain);
        if ($API->hasError())
            $errors[] = $API->getErrors();

        $redirects = array();
        foreach ($result->result->data->redirect as $key => $rd) {
            if ($rd->mode == "single")
                continue;
            $surce = str_replace("." . $domain, "", (string) $rd->source);
            $redirects[] = array(
                "id" => $rd->source,
                "source" => (string) $rd->source,
                "target" => (string) $rd->target,
                "mode" => (string) $rd->mode,
                "title" => $rd->title,
            );
        }
    } catch (Exception $ex) {
        $errrors[] = $ex->getMessage();
    }

    if (!empty($errors))
        $call['errors'] = $errors;

    $call['redirects'] = $redirects;
    $call['domain'] = $params['sld'] . '.' . $params['tld'];
    $call['domainId'] = $params['domainid'];

    return array(
        'templatefile' => 'domainForwarding',
        'breadcrumb' => ' > <a href="#">Domain Forwarding</a>',
        'vars' => $call
    );
}

/**
 * FUNCTION InterNetX_changeOwner
 * Change owner domain in client area
 * @param array $params
 * @return array $return
 */
function InterNetX_changeOwner($params)
{
    try
    {
        $countryData = json_decode(file_get_contents(ROOTDIR . DS . 'resources' . DS . 'country' . DS. 'dist.countries.json'),true);
        $API = new InterNetX_API($params['serverHost'], $params['serverUsername'], $params['serverPassword'], $params['serverContext'], $params['sandboxServerUsername'], $params['sandboxServerPassword'], $params['sandboxServerContext'], $params['debug'], $params['sandboxMode']);
        $API->setReplyTo($params['replyTo']);
        if (isset($params['original']))
            $params = $params['original'];

        $idna_convert = new idna_convert();
        $domain = $idna_convert->encode($params['sld'] . '.' . $params['tld']);
        $errors = array();
        $info = $API->domainInfo($domain);
        if ($API->hasError())
            $errors[] = $API->getErrors();
        $fields = (array) Capsule::table('tbldomainsadditionalfields')->join('tbldomains', 'tbldomains.id', '=', 'tbldomainsadditionalfields.domainid')
                        ->select('tbldomainsadditionalfields.*')->where('tbldomains.domain', '=', $domain)->orderBy('id', 'asc')->get();
        foreach ($fields as $field) {
            $params['additionalfields'][$field->name] = $field->value;
        }

        $extensions = InterNetX_Extension::assing($params['tld'], $params['additionalfields']);

        if (!empty($_POST)) {
            foreach ($_POST['domainContacts'] as $key => $val) {
                if (empty($val)) {
                    $contact[$key] = (string) $info->result->data->domain->$key;
                } else {
                    $details = (array) Capsule::table('tblcontacts')->where('id', '=', $val)->where('userid', '=', (int) $_SESSION['uid'])->first();

                    $type = ($key == "ownerc") ? null : "admin";

                    if (!empty($details['address1']) && !empty($details['address2']))
                        $address = $details['address1'] . " " . $details['address2'];
                    else
                        $address = $details['address1'];

                    $user = array(
                        'id' => $contact,
                        'type' => ($details['companyname'] == "") ? "PERSON" : "ORG",
                        'firstName' => $details['firstname'],
                        'lastName' => $details['lastname'],
                        'organization' => $details['companyname'],
                        'address' => $address,
                        'city' => $details['city'],
                        'state' => $details['state'],
                        'postCode' => $details['postcode'],
                        'country' => $details['country'],
                        'countryName' => $countryData[$details['country']]['name'],
                        'phone' => InterNetX_FormatPhone($details['fullphonenumber']),
                        //'fax' => InterNetX_FormatPhone($details['fullphonenumber']),
                        'email' => $details['email'],
                    );

                    if ($key != "ownerc" && ($params['tld'] == "de" || $params['tld'] == "es"))
                        $user['type'] = "PERSON";

                    $result = $API->contactCreate($user, $extensions);
                    if ($API->hasError()) {
                        $errors[] = $API->getErrors();
                    } else {
                        $contact[$key] = (string) $result->result->status->object->value;
                    }
                }
            }

            $client = internetx_getClientDetails($params['domainid']);
            $domainContacts = $_POST['domainContacts'];
            $autoinfo = (string) $info->result->data->domain->authinfo;
            $change = $API->domainOwnerChange($domain, $contact, $autoinfo, $client['email']);
            if ($API->hasError())
                $errors[] = $API->getErrors();
            else
                $infoMsg = (string) $change->result->status->text;
        }else {

            $domainContacts = array(
                "ownerc" => (string) $info->result->data->domain->ownerc,
                "adminc" => (string) $info->result->data->domain->adminc,
                "techc" => (string) $info->result->data->domain->techc,
                "zonec" => (string) $info->result->data->domain->zonec,
            );
        }
    } catch (Exception $ex) {
        $errrors[] = $ex->getMessage();
    }

    if (!empty($errors))
        $call['errors'] = $errors;

    if ($infoMsg)
        $call['info'] = $infoMsg;

    $call['domain'] = $params['sld'] . '.' . $params['tld'];
    $call['domainContacts'] = $domainContacts;
    $call['domainId'] = $params['domainid'];
    $call['contacts2'] = "<option value=''>Do not change Contact</option>";
    $query = Capsule::table('tblcontacts')->where('userid', '=', (int) $_SESSION['uid'])->get();
    foreach ($query as $row) {
        $call['contacts2'] .= "<option value='" . $row->id . "'>" . $row->firstname . ' ' . $row->lastname . '</option>';
    }

    //$call['contacts2'] .= '<option value="---addnew---">Add new Contact..</option>';
    return array(
        'templatefile' => 'changeOwner',
        'breadcrumb' => ' > <a href="#">Change Owner</a>',
        'vars' => $call
    );
}

/**
 * Check Domain Availability.
 *
 * Determine if a domain or group of domains are available for
 * registration or transfer.
 */
function InterNetX_CheckAvailability($params)
{
    try {
        $API = new InterNetX_API($params['serverHost'], $params['serverUsername'], $params['serverPassword'], $params['serverContext'], $params['sandboxServerUsername'], $params['sandboxServerPassword'], $params['sandboxServerContext'], $params['debug'], $params['sandboxMode']);
        $API->setReplyTo($params['replyTo']);
        $results = new ResultsList();

        $idna_convert = new idna_convert();

        foreach ($params[ 'tldsToInclude' ] as $key => $TLDS) {

            //$params['tldsToInclude'][$key] = str_replace('.', '', $TLDS);
			$params['tldsToInclude'][$key] = ltrim($TLDS, '.');
        }

        if(!empty($params[ 'tldsToInclude' ]))
        {
            $checkResult = $API->autodns_whois(array($params['sld']), $params['tldsToInclude']);
        }else{
            exit();
        }
        //$checkResult = $API->autodns_whois(array($params['sld']), $params['tldsToInclude']);


        foreach ($checkResult as $domain => $value) {
            $domainParts = explode('.', $domain);
            $sld = $domainParts[0];
            unset($domainParts[0]);
            $tld = implode('.', $domainParts);

            $searchResult = new SearchResult($sld, '.'.$tld);
            // Determine the appropriate status to return
            if ($value['status'] == 'free') {
                $status = SearchResult::STATUS_NOT_REGISTERED;
            } elseif ($value['status'] == 'registered') {
                $status = SearchResult::STATUS_REGISTERED;
            } elseif ($value['status'] == 'reserved') {
                $status = SearchResult::STATUS_RESERVED;
            }elseif ($value['status'] == 'premium') {
                $status = SearchResult::STATUS_NOT_REGISTERED;
            } else {
                $status = SearchResult::STATUS_TLD_NOT_SUPPORTED;
            }
            $searchResult->setStatus($status);

            // Return premium information if applicable
            if ($value['premium']) {
                //check if premium domains addon and Lookup Provider are set
                $lookupProvider       = Capsule::table('tblconfiguration')->select('value')->where('setting', '=', 'domainLookupRegistrar')->first();
                $isAddonActive        = Capsule::table('tbladdonmodules')->select('value')->where('module', '=', 'InterNetX')->exists();
//        $isPremiumDomainsOn = Capsule::table('tblconfiguration')->select('value')->where('setting', '=', 'PremiumDomains')->value();
	$isPremiumDomainsOn = Capsule::table('tblconfiguration')->where('setting', '=', 'PremiumDomains')->value('value');
                $isPremiumClassExists = Capsule::table('mod_InterNetXtblpremiumclasses')->select('id')->where('class_name', '=', $value['premiumClass'])->exists();

                if($lookupProvider->value == 'InterNetX' && $isAddonActive && $isPremiumDomainsOn == '1' && $isPremiumClassExists)
                {
	                $className = $value['premiumClass'];
	                $premiumclassID = Capsule::table('mod_InterNetXtblpremiumclasses')->select('id')->where('class_name', '=', $className)->first();
	                $domianPricing = Capsule::select('SELECT * FROM mod_InterNetXtblpremiumpricing WHERE relid='.$premiumclassID->id.' AND currency=1');

	                $searchResult->setPremiumDomain(true);

	                foreach ($domianPricing as $pricing) {
	                    if($pricing->type == 'domainregister')
	                    {
	                        $registerPrices = $pricing->{'1years'};
	                        $currencyCodes = Capsule::table('tblcurrencies')->select('code')->where('id', '=', $pricing->currency)->first();
	                    }elseif ($pricing->type == 'domaintransfer') {
	                        $transferPrices = $pricing->{'1years'};
	                    }elseif ($pricing->type == 'domainrenew') {
	                        $renewPrices = $pricing->{'1years'};
	                    }
	                }
	                if($registerPrices == '0.00')
	                {
	                    $searchResult->setStatus(SearchResult::STATUS_RESERVED);
	                }

	                $searchResult->setPremiumCostPricing(
	                    array(
	                        'register' => $registerPrices,
	                        'renew' => $transferPrices,
	                        'transfer' => $renewPrices,
	                        'CurrencyCode' => $currencyCodes->code,
	                        'skipMarkup' => true,
	                    )
	                );
                }else{
                    $searchResult->setStatus(SearchResult::STATUS_UNKNOWN);
                    $results->append($searchResult);
                    return $results;
                }

            }
            // Append to the search results list
            $results->append($searchResult);
        }

        logModuleCall(
                    "InterNetX", 'Metoda checkavailability', print_r($_SESSION, true), '', print_r($_REQUEST, true), array()
        );

        return $results;

    } catch (\Exception $e) {
        return array(
            'error' => $e->getMessage(),
        );
    }

}

 function InterNetX_GetDomainSuggestions($params)
{
try {
        $API = new InterNetX_API($params['serverHost'], $params['serverUsername'], $params['serverPassword'], $params['serverContext'], $params['sandboxServerUsername'], $params['sandboxServerPassword'], $params['sandboxServerContext'], $params['debug'], $params['sandboxMode']);
        $API->setReplyTo($params['replyTo']);
        $results = new ResultsList();
        //$score = 2;
        $idna_convert = new idna_convert();

        foreach ($params[ 'tldsToInclude' ] as $key => $TLDS) {

            //$params['tldsToInclude'][$key] = str_replace('.', '', $TLDS);
			$params['tldsToInclude'][$key] = ltrim($TLDS, '.');
        }

        $checkResult = $API->autodns_whois(array($params['searchTerm']), $params['tldsToInclude']);

        foreach ($checkResult as $domain => $value) {
            if($value['status'] == 'free' || $value['status'] == 'premium')
            {
                $domainParts = explode('.', $domain);
                $sld = $domainParts[0];
                unset($domainParts[0]);
                $tld = implode('.', $domainParts);
                $searchResult = new SearchResult($sld, '.'.$tld);

                // All domain suggestions should be available to register
                $searchResult->setStatus(SearchResult::STATUS_NOT_REGISTERED);

                // Used to weight results by relevance
                //$searchResult->setScore($score++);

                // Return premium information if applicable
                if ($value['premium'] == 1) {
                    $className = $value['premiumClass'];
                    $premiumclassID = Capsule::table('mod_InterNetXtblpremiumclasses')->select('id')->where('class_name', '=', $className)->first();
                    if($premiumclassID == NULL)
                    {
                        continue;
                    }

                    $domianPricing = Capsule::select('SELECT * FROM mod_InterNetXtblpremiumpricing WHERE relid='.$premiumclassID->id.' AND currency=1');

                    $searchResult->setPremiumDomain(true);

                    foreach ($domianPricing as $pricing) {
                        if($pricing->type == 'domainregister')
                        {
                            $registerPrices = $pricing->{'1years'};
                            $currencyCodes = Capsule::table('tblcurrencies')->select('code')->where('id', '=', $pricing->currency)->first();
                        }elseif ($pricing->type == 'domaintransfer') {
                            $transferPrices = $pricing->{'1years'};
                        }elseif ($pricing->type == 'domainrenew') {
                            $renewPrices = $pricing->{'1years'};
                        }
                    }
                    if($registerPrices == '0.00')
                    {
                        $searchResult->setStatus(SearchResult::STATUS_RESERVED);
                    }

                    $searchResult->setPremiumCostPricing(
                        array(
                            'register' => $registerPrices,
                            'renew' => $transferPrices,
                            'transfer' => $renewPrices,
                            'CurrencyCode' => $currencyCodes->code,
                            'skipMarkup' => true,
                        )
                    );
                }
                // Append to the search results list
                $results->append($searchResult);
            }

        }
        \WHMCS\Session::setAndRelease("suggestionsAreReady" ,'yes');
        //\WHMCS\Session::set("suggestionsAreReady" ,'yes');
        //$_SESSION['suggestionsAreReady'] = 'yes';

        logModuleCall(
                "InterNetX", 'Metoda get suggestions', print_r($_SESSION, true), '', print_r($_REQUEST, true), array()
        );
        return $results;

    } catch (\Exception $e) {
        return array(
            'error' => $e->getMessage(),
        );
    }

//
//    $results = new ResultsList();
//    return $results;
}

function InterNetX_FormatPhone($number){
    $phone = explode(".",$number);
    $ccPart = $phone[0];
    $phonePart = $phone[1];

    $start = substr($phonePart, 0, 3); //we just assume the first 3 digits of the number as dialling code
    $end = substr($phonePart, 3);

    return $ccPart."-".$start."-".$end;
}
